(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["tsx-editor-core"],{

/***/ "../tsx-editor/lib/components/Editor.js":
/*!**********************************************!*\
  !*** ../tsx-editor/lib/components/Editor.js ***!
  \**********************************************/
/*! exports provided: Editor, default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Editor\", function() { return Editor; });\n/* harmony import */ var monaco_editor__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! monaco-editor */ \"../../node_modules/monaco-editor/esm/vs/editor/editor.main.js\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ \"react\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var _TypeScriptSnippet__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./TypeScriptSnippet */ \"../tsx-editor/lib/components/TypeScriptSnippet.js\");\n\n\n\nvar Editor = function (props) {\n    var width = props.width, height = props.height, onChange = props.onChange, _a = props.language, language = _a === void 0 ? 'typescript' : _a, code = props.code;\n    // Hooks must be called unconditionally, so we have to create a backup ref here even if we\n    // immediately throw it away to use the one passed in.\n    var backupModelRef = react__WEBPACK_IMPORTED_MODULE_1__[\"useRef\"]();\n    var modelRef = props.modelRef || backupModelRef;\n    var ref = react__WEBPACK_IMPORTED_MODULE_1__[\"useRef\"](null);\n    var style = { width: width, height: height };\n    react__WEBPACK_IMPORTED_MODULE_1__[\"useEffect\"](function () {\n        // Fetching Fabric typings to allow for intellisense in editor\n        fetch('https://unpkg.com/office-ui-fabric-react/dist/office-ui-fabric-react.d.ts').then(function (response) {\n            response.text().then(function (fabricTypings) {\n                monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript.typescriptDefaults.addExtraLib(fabricTypings, 'file:///node_modules/@types/office-ui-fabric-react/index.d.ts');\n            });\n        });\n        monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript.typescriptDefaults.setCompilerOptions({\n            allowNonTsExtensions: true,\n            target: monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript.ScriptTarget.ES5,\n            jsx: monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript.JsxEmit.React,\n            alwaysStrict: true,\n            jsxFactory: 'React.createElement',\n            experimentalDecorators: true,\n            preserveConstEnums: true,\n            outDir: 'lib',\n            module: monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript.ModuleKind.ESNext,\n            lib: ['es5', 'dom']\n        });\n        monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript.typescriptDefaults.setDiagnosticsOptions({ noSemanticValidation: true });\n        var model = (modelRef.current = monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"editor\"].createModel(code, language, monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"Uri\"].parse('file:///main.tsx')));\n        if (onChange) {\n            onChange(model);\n        }\n        var editor = monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"editor\"].create(ref.current, {\n            model: model,\n            value: code,\n            language: language,\n            minimap: { enabled: false },\n            fontFamily: _TypeScriptSnippet__WEBPACK_IMPORTED_MODULE_2__[\"codeFontFamily\"]\n        });\n        editor.onDidChangeModelContent(function () {\n            if (onChange) {\n                onChange(editor.getModel());\n            }\n        });\n        return function () {\n            editor.getModel().dispose();\n            editor.dispose();\n            modelRef.current = undefined;\n        };\n    }, [onChange, language, code, modelRef]);\n    return react__WEBPACK_IMPORTED_MODULE_1__[\"createElement\"](\"div\", { ref: ref, style: style });\n};\n/* harmony default export */ __webpack_exports__[\"default\"] = (Editor);\n//# sourceMappingURL=Editor.js.map\n\n//# sourceURL=webpack:///../tsx-editor/lib/components/Editor.js?");

/***/ }),

/***/ "../tsx-editor/lib/transpiler/transpile.js":
/*!*************************************************!*\
  !*** ../tsx-editor/lib/transpiler/transpile.js ***!
  \*************************************************/
/*! exports provided: transpile, evalCode */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"transpile\", function() { return transpile; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"evalCode\", function() { return evalCode; });\n/* harmony import */ var monaco_editor__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! monaco-editor */ \"../../node_modules/monaco-editor/esm/vs/editor/editor.main.js\");\n/* harmony import */ var _exampleTransform__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./exampleTransform */ \"../tsx-editor/lib/transpiler/exampleTransform.js\");\n\n\n// This is intentionally not an async function, because debugging within transpiled async functions\n// is next to impossible.\nfunction transpile(model) {\n    var transpiledOutput = { error: undefined, outputString: undefined };\n    var filename = model.uri.toString();\n    return monaco_editor__WEBPACK_IMPORTED_MODULE_0__[\"languages\"].typescript\n        .getTypeScriptWorker()\n        .then(function (makeWorker) { return makeWorker(model.uri); })\n        .then(function (worker) {\n        return worker.getEmitOutput(filename).then(function (output) {\n            if (output.emitSkipped) {\n                transpiledOutput.error = 'Error transpiling code';\n            }\n            else {\n                transpiledOutput.outputString = output.outputFiles[0].text;\n            }\n            return transpiledOutput;\n        });\n    })\n        .catch(function (ex) {\n        transpiledOutput.error = ex.message;\n        return transpiledOutput;\n    });\n}\n/**\n * Tranforms the code since the given code might have unsupported imports and then evals the code.\n *\n * @param code - Code to transform and eval\n * @param divId - `id` of the `div` element where the example will be rendered into after transforming\n * @returns Returns undefined if the transform was successful, or the error message if it was unsuccessful.\n */\nfunction evalCode(code, divId) {\n    try {\n        // tslint:disable:no-eval\n        var transfromedExample = Object(_exampleTransform__WEBPACK_IMPORTED_MODULE_1__[\"transformExample\"])(code, divId);\n        if (transfromedExample.output !== undefined) {\n            eval(transfromedExample.output);\n        }\n        else {\n            return transfromedExample.error;\n        }\n    }\n    catch (ex) {\n        // Log the error to the console so people can see the full stack/etc if they want\n        console.error(ex);\n        return ex.message;\n    }\n    return undefined;\n}\n//# sourceMappingURL=transpile.js.map\n\n//# sourceURL=webpack:///../tsx-editor/lib/transpiler/transpile.js?");

/***/ })

}]);